module tool;

public {
    import icanvas;
    import tk.events;
}

/*
interface IToolStack {
    void push(Tool tool);
    void pop();
    void replace(Tool tool);
}
*/

abstract class Tool {
    /*
    abstract bool is_sticky();
    abstract bool is_replaceable();
    */

    /*
    abstract void start(IToolStack tool_stack);
    abstract void stop(IToolStack tool_stack);
    */

    //void draw(const Viewport viewport, in Rectangle damage, Context model_cr, Context pixel_cr) const;

    bool handle_button_press(Viewport viewport, in ButtonEvent event);
    bool handle_button_release(Viewport viewport, in ButtonEvent event);
    bool handle_motion(Viewport viewport, in MotionEvent event);
    bool handle_scroll(Viewport viewport, in ScrollEvent event);
    //bool handle_expose(Viewport viewport, ExposeEvent event);
    //bool handle_enter(Viewport viewport, CrossingEvent event);
    //bool handle_leave(Viewport viewport, CrossingEvent event);
    //bool handle_focus_in(Viewport viewport, FocusEvent event);
    //bool handle_focus_out(Viewport viewport, FocusEvent event);
    bool handle_key_press(Viewport viewport, in KeyEvent event);
    bool handle_key_release(Viewport viewport, in KeyEvent event);
}

